extends Node

export var battle_turns : int = 10

var _turn_number : int = 1
var _unit_turns_completed : int = 0
var _unit_count : int = 0

signal part_of_turn_done


func _ready() -> void:
	_start_battle()


func _start_battle():
	for i in battle_turns:
		#yield here means that it waits until the fucntion is completed
		yield(_start_unit_turns("friends"), "completed")
		yield(_start_unit_turns("foes"), "completed")
		_turn_number = _turn_number + 1


func _add_unit_turns_completed():
	#this function is called by the signal turn completed
	_unit_turns_completed = _unit_turns_completed + 1


func _start_unit_turns(unit_group_name : String):
	var unit_array = get_tree().get_nodes_in_group(unit_group_name)
	_unit_count = unit_array.size()
	#connects the signal turn completed to the _add_unit_turns_completed method
	for i in _unit_count:		
		unit_array[i].connect("turn_completed", self, "_add_unit_turns_completed")
	#start the turn for all nodes in the specified group
	get_tree().call_group(unit_group_name, "start_turn")
	#wait until the number of turn_completed signals recieved is equal to the unit count
	yield(self, "part_of_turn_done")
	
	#reset for next part of turn
	_unit_count = 0
	_unit_turns_completed = 0
	for i in _unit_count:
		unit_array[i].disconnect("turn_completed", self, "_add_unit_turns_completed")


func _process(delta: float) -> void:
	
	#wait until the number of turn_completed signals recieved is equal to the unit count
	if _unit_turns_completed >= _unit_count:
		emit_signal("part_of_turn_done")
