extends Node

signal remove_selection

var SELECTION_AREA = preload("res://src/nodes/world/SelectionArea.tscn")

onready var Grid = get_parent()


func create_selection_from_array(coordinates, color_index : int):
	for i in coordinates.size():
		create_selection(coordinates[i], color_index)


func create_selection(coordinate : Vector2, color_index : int):
	var instanced_selection_area = SELECTION_AREA.instance()
	
	connect("remove_selection", instanced_selection_area, "queue_free")
	
	instanced_selection_area.position = Grid.coordinates_to_position(coordinate, Grid.TERRAIN_GRID[coordinate.x][coordinate.y][1])
	if (Grid.get_tile_behind_state(coordinate) == "p"):
		instanced_selection_area.z_index = Grid.TERRAIN_GRID[coordinate.x][coordinate.y][1]
	instanced_selection_area.selection_color_index = color_index
	
	add_child(instanced_selection_area)


#func _ready() -> void:
#	yield(get_tree().create_timer(0.1), "timeout")
#	create_selection(Vector2(29,18))
#	create_selection(Vector2(29,19))
#	yield(get_tree().create_timer(10), "timeout")
#	emit_signal("remove_selection")
#	print("destroyed")
